minor bug fix
[distro-setup] / brc
diff --git a/brc b/brc
index 5b3054ac4f5535e54f614c7287fd88816a72a400..37e09a0c13399224b748366482fc84b22f7a96ed 100644 (file)
--- a/brc
+++ b/brc
@@ -1,4 +1,6 @@
 #!/bin/bash
+# Copyright (C) 2019 Ian Kelling
+# SPDX-License-Identifier: AGPL-3.0-or-later
 # this gets sourced. shebang is just for file mode detection
 
 # note, to catch errors in functions but not outside, do:
@@ -7,10 +9,7 @@
 # trap 'trap ERR' RETURN
 
 
-
-############
-# settings #
-############
+# * settings
 
 CDPATH=.
 
@@ -21,7 +20,7 @@ set -o pipefail
 unalias -a
 
 # remove gnome keyring warning messages
-# there is probably a more proper way, but I didn't find any easily on google
+# there is probably a more proper way, but I didnt find any easily on google
 # now using xfce+xmonad instead of vanilla xmonad, so disabling this
 #unset GNOME_KEYRING_CONTROL
 
@@ -29,29 +28,19 @@ unalias -a
 shopt -s extglob
 # include .files when globbing, but ignore files name . and ..
 # setting this also sets dotglob.
-# Note, this doesn't work in bash 4.4 anymore, for paths with
-# more than 1 directory, like a/b/.foo, since * is fixed to not match /
-export GLOBIGNORE=*/.:*/..
+export GLOBIGNORE="*/.:*/.."
 
-# broken with bash_completion package. Saw a bug for this once. Don't anymore.
+# broken with bash_completion package. Saw a bug for this once. dont anymore.
 # still broken in wheezy
 # still buggered in latest stable from the web, version 2.1
 # perhaps its fixed in newer git version, which fails to make for me
 # this note is from 6-2014.
-# Also, enabling this before sourcing .bashrc makes PATH be empty.
+# still broken in flidas.
 #shopt -s nullglob
 
 # make tab on an empty line do nothing
 shopt -s no_empty_cmd_completion
 
-# advanced completion
-# http://bash-completion.alioth.debian.org/
-# might be sourced by the system already, but I've noticed it not being sourced before
-if ! type _init_completion &> /dev/null && [[ -r "/usr/share/bash-completion/bash_completion" ]]; then
-    . /usr/share/bash-completion/bash_completion
-fi
-
-
 # fix spelling errors for cd, only in interactive shell
 shopt -s cdspell
 # append history instead of overwritting it
@@ -64,64 +53,91 @@ shopt -s cmdhist
 shopt -s globstar
 
 
-# inside emcas fixes
+# inside emacs fixes
 if [[ $RLC_INSIDE_EMACS ]]; then
-    # EMACS is used by bash on startup, but we don't need it anymore.
-    # plus I hit a bug in a makefile which inherited it
-    unset EMACS
-    export RLC_INSIDE_EMACS
-    export PAGER=cat
-    export MANPAGER=cat
-    # scp completion does not work, but this doesn't fix it. todo, figure this out
-    complete -r scp &> /dev/null
-    # todo, remote file completion fails, figure out how to turn it off
-    export NODE_DISABLE_COLORS=1
-    # This get's rid of ugly terminal escape chars in node repl
-    # sometime, I'd like to have completion working in emacs shell for node
-    # the offending chars can be found in lib/readline.js,
-    # things that do like:
-    # stream.write('\x1b[' + (x + 1) + 'G');
-    # We can remove them and keep readline, for example by doing this
-    # to start a repl:
-    #!/usr/bin/env nodejs
-    # var readline = require('readline');
-    # readline.cursorTo = function(a,b,c) {};
-    # readline.clearScreenDown = function(a) {};
-    # const repl = require('repl');
-    # var replServer = repl.start('');
-    #
-    # no prompt, or else readline complete seems to be confused, based
-    # on our column being different? node probably needs to send
-    # different kind of escape sequence that is not ugly. Anyways,
-    # completion doesn't work yet even with the ugly prompt, so whatever
-    #
-    export NODE_NO_READLINE=1
+  # EMACS is used by bash on startup, but we dont need it anymore.
+  # plus I hit a bug in a makefile which inherited it
+  unset EMACS
+  export RLC_INSIDE_EMACS
+  export PAGER=cat
+  export MANPAGER=cat
+  # scp completion does not work, but this doesnt fix it. todo, figure this out
+  complete -r scp &> /dev/null
+  # todo, remote file completion fails, figure out how to turn it off
+  export NODE_DISABLE_COLORS=1
+  # This gets rid of ugly terminal escape chars in node repl
+  # sometime, Id like to have completion working in emacs shell for node
+  # the offending chars can be found in lib/readline.js,
+  # things that do like:
+  # stream.write('\x1b[' + (x + 1) + 'G');
+  # We can remove them and keep readline, for example by doing this
+  # to start a repl:
+  #!/usr/bin/env nodejs
+  # var readline = require('readline');
+  # readline.cursorTo = function(a,b,c) {};
+  # readline.clearScreenDown = function(a) {};
+  # const repl = require('repl');
+  # var replServer = repl.start('');
+  #
+  # no prompt, or else readline complete seems to be confused, based
+  # on our column being different? node probably needs to send
+  # different kind of escape sequence that is not ugly. Anyways,
+  # completion doesnt work yet even with the ugly prompt, so whatever
+  #
+  export NODE_NO_READLINE=1
 
 fi
 
+# emacs has a different default search path than the info command. This
+# adds the info defaults to emacs, but not the reverse, because I dun
+# care much about the cli. The search path is only on the cli if you run
+# "info xxx", or in emacs if you run '(info xxx)', so not that
+# important, but might as well fix it.
+
+# info info says this path is what was compiled, and its not documented
+# anywhere. Through source grepping, i found it in filesys.h of the info
+# source in trisquel flidas.
+#
+# Traling : means for emacs to add its own stuff on to the end.
+
+export INFOPATH=$PATH:/usr/local/info:/usr/info:/usr/local/lib/info:/usr/lib/info:/usr/local/gnu/info:/usr/local/gnu/lib/info:/usr/gnu/info:/usr/gnu/lib/info:/opt/gnu/info:/usr/share/info:/usr/share/lib/info:/usr/local/share/info:/usr/local/share/lib/info:/usr/gnu/lib/emacs/info:/usr/local/gnu/lib/emacs/info:/usr/local/lib/emacs/info:/usr/local/emacs/info:.:
 
 if [[ $- == *i* ]]; then
-    # for readline-complete.el
-    if [[ $RLC_INSIDE_EMACS ]]; then
-        # all for readline-complete.el
-        stty echo
-        bind 'set horizontal-scroll-mode on'
-        bind 'set print-completions-horizontally on'
-        bind '"\C-i": self-insert'
-    else
-        # arrow keys. for other terminals, see http://unix.stackexchange.com/questions/10806/how-to-change-previous-next-word-shortcut-in-bash
-        if [[ $TERM == "xterm" ]]; then
-            bind '"\e[1;5C": shell-forward-word' 2>/dev/null
-            bind '"\e[1;5D": shell-backward-word' 2>/dev/null
-        else
-            bind '"\eOc": shell-forward-word'
-            bind '"\eOd": shell-backward-word'
-        fi
-        # terminal keys: C-c, C-z. the rest defined by stty -a are, at least in
-        # gnome-terminal, overridden by bash, or disabled by the system
-        stty werase undef lnext undef stop undef start undef
+  # for readline-complete.el
+  if [[ $RLC_INSIDE_EMACS ]]; then
+    # all for readline-complete.el
+    stty echo
+    bind 'set horizontal-scroll-mode on'
+    bind 'set print-completions-horizontally on'
+    bind '"\C-i": self-insert'
+  else
+
+    if [[ $KONSOLE_PROFILE_NAME ]]; then
+      TERM=xterm-256color
+    fi
 
+    # todo: not sure this works in sakura
+    #stty werase undef
+    #bind "\C-w": kill-region
+    # sakura == xterm-256color
+    # konsole == xterm
+    if [[ $TERM == xterm* ]]; then
+      # control + arrow keys. for other terminals, see http://unix.stackexchange.com/questions/10806/how-to-change-previous-next-word-shortcut-in-bash
+      bind '"\e[1;5C": shell-forward-word' 2>/dev/null
+      bind '"\e[1;5D": shell-backward-word' 2>/dev/null
+    else
+      # make ctrl-backspace work. for konsole, i fixed it through
+      # /home/iank/.local/share/konsole/default.keytab
+      stty werase '^h'
+      bind '"\eOc": shell-forward-word'
+      bind '"\eOd": shell-backward-word'
     fi
+    # i cant remember why i did this, probably to free up some keys to bind
+    # to other things in bash.
+    # other than C-c and C-z, the rest defined by stty -a are, at least in
+    # gnome-terminal, overridden by bash, or disabled by the system
+    stty  lnext undef stop undef start undef
+  fi
 
 fi
 
@@ -133,86 +149,63 @@ PS4='$LINENO+ '
 # default HISTFILESIZE is 500 and could clobber our history
 HISTFILESIZE=
 # max commands 1 session can append/read from history
-HISTSIZE=100000
-# my own history size limit based on lines
-HISTFILELINES=1000000
-HISTFILE=$HOME/.bh
+HISTSIZE=1000000
 # the time format display when doing the history command
 # also, setting this makes the history file record time
 # of each command as seconds from the epoch
-HISTTIMEFORMAT="%I:%M %p %m/%d "
-# consecutive duplicate lines don't go in history
+HISTTIMEFORMAT="%Y-%m-%d %I:%M %p "
+# consecutive duplicate lines dont go in history
 HISTCONTROL=ignoredups
 # works in addition to HISTCONTROL to do more flexible things
 # it could also do the same things as HISTCONTROL and thus replace it,
 # but meh. dunno why, but just " *" does glob expansion, so use [ ] to avoid it.
-HISTIGNORE='k *:[ ]*'
+HISTIGNORE='pass *:[ ]*:otp *:oathtool *'
 
 export BC_LINE_LENGTH=0
 
+export PROFILE_TASKS_TASK_OUTPUT_LIMIT=100
 
-# note, if I use a machine I don't want files readable by all users, set
+# note, if I use a machine I dont want files readable by all users, set
 # umask 077  # If fewer than 4 digits are entered, leading zeros are assumed
 
-C_DEFAULT_DIR=/a
-
-
-###################
-## include files ###
-###################
-for _x in /a/bin/distro-functions/src/* /a/bin/!(githtml)/*-function?(s); do
-    source "$_x"
-done
-unset _x
-# so I can share my bashrc
-for x in /a/bin/bash_unpublished/source-!(.#*); do source $x; done
-source $(dirname $(readlink -f $BASH_SOURCE))/path_add-function
-source /a/bin/log-quiet/logq-function
-path_add /a/exe
-path_add --ifexists --end /a/opt/adt-bundle*/tools /a/opt/adt-bundle*/platform-tools
-export WCDHOME=/a
-# based on readme.debian. dunno if this will break on other distros.
-_x=/usr/share/wcd/wcd-include.sh
-if [[ -e $_x ]]; then source $_x; fi
-
-
-###############
-### aliases ###
-###############
-
-# very few aliases, functions are always preferred.
-
-# ancient stuff.
-if [[ $OS == Windows_NT ]]; then
-    alias ffs='cygstart "/c/Program Files (x86)/Mozilla Firefox/firefox.exe" -P scratch'
-    export DISPLAY=nt
-    alias j='command cygpath'
-    alias t='command cygstart'
-    alias cygstart='echo be quick, use the alias "t" instead :\)'
-    alias cygpath='echo be quick, use the alias "j" instead :\)'
-fi
-
-
-
-# keep this in mind? good for safety.
-# alias cp='cp -i'
-# alias mv='mv -i'
-
-
-# remove any default aliases for these
-unalias ls ll grep &>/dev/null ||:
-
+# i for insensitive. the rest from
+# X means dont remove the current screenworth of output upon exit
+# R means to show colors n things
+export LESS=RXi
+export SYSTEMD_LESS=$LESS
 
 
+# * include files
 
 
 
+# if someone exported $SOE (stop on error), catch errors.
+#
+# Note, on debian this results in the following warning when in ssh,
+# hich I haven't figured out how to fix. It doesn't happen if we source
+# after the shell has started
+#
+# bash: /usr/share/bashdb/bashdb-main.inc: No such file or directory
+# bash: warning: cannot start debugger; debugging mode disabled
+if [[ $SOE ]]; then
+  if [[ -e /a/bin/errhandle/err ]]; then
+    source /a/bin/errhandle/err
+  fi
+fi
 
+# based on readme.debian. dunno if this will break on other distros.
+if [[ -s /usr/share/wcd/wcd-include.sh ]]; then
+  source /usr/share/wcd/wcd-include.sh
+fi
 
+if [[ -s /a/bin/small-misc-bash/ll-function ]]; then
+  # shellcheck source=/a/bin/small-misc-bash/ll-function
+  source /a/bin/small-misc-bash/ll-function
+elif [[ -s ~/.iank/ll-function ]]; then
+  source ~/.iank/ll-function
+fi
 
-#####################
-###  functions   ####
-#####################
+# * functions
 
 
 ..() { c ..; }
@@ -221,1255 +214,973 @@ unalias ls ll grep &>/dev/null ||:
 .....() { c ../../../..; }
 ......() { c ../../../../..; }
 
-
 # file cut copy and paste, like the text buffers :)
-# I havn't tested these.
-_fbufferinit() { # internal use by
-    ! [[ $my_f_tempdir ]] && my_f_tempdir=$(mktemp -d)
-    rm -rf "$my_f_tempdir"/*
+# I havnt tested these.
+_fbufferinit() { # internal use
+  ! [[ $my_f_tempdir ]] && my_f_tempdir=$(mktemp -d)
+  rm -rf "${my_f_tempdir:?}"/*
 }
 fcp() { # file cp
-    _fbufferinit
-    cp "$@" "$my_f_tempdir"/
+  _fbufferinit
+  cp "$@" "$my_f_tempdir"/
 }
 fct() { # file cut
-    _fbufferinit
-    mv "$@" "$my_f_tempdir"/
+  _fbufferinit
+  mv "$@" "$my_f_tempdir"/
 }
 fpst() { # file paste
-    [[ $2 ]] && { echo too many arguments; return 1; }
-    target=${1:-.}
-    cp "$my_f_tempdir"/* "$target"
-}
-
-
-# todo, update this
-complete -F _longopt la lower low rlt rld rl lld ts ll dircp ex fcp fct fpst gr
-
-
-_cdiff-prep() {
-    # join options which are continued to multiples lines onto one line
-    local first=true
-    grep -vE '^([ \t]*#|^[ \t]*$)' "$1" | while IFS= read -r line; do
-        # remove leading spaces/tabs. assumes extglob
-        if [[ $line == "[      ]*" ]]; then
-            line="${line##+( )}"
-        fi
-        if $first; then
-            pastline="$line"
-            first=false
-        elif [[ $line == *=* ]]; then
-            echo "$pastline" >> "$2"
-            pastline="$line"
-        else
-            pastline="$pastline $line"
-        fi
-    done
-    echo "$pastline" >> "$2"
+  [[ $2 ]] && { echo too many arguments; return 1; }
+  target=${1:-.}
+  cp "$my_f_tempdir"/* "$target"
 }
 
 _khfix_common() {
-    local h=${1##*@}
-    local x
-    ssh-keygen -R $h -f $(readlink -f ~/.ssh/known_hosts)
-    x=$(timeout 1 ssh -oBatchMode=yes -v $1 |& sed -rn "s/debug1: Connecting to $h \[([^\]*)].*/\1/p")
-    if [[ ! $x ]]; then
-        echo "khfix: ssh failed"
-        return 1
-    fi
-    echo "khfix: removing key for $x"
-    ssh-keygen -R $x -f $(readlink -f ~/.ssh/known_hosts)
+  local host=${1##*@}
+  local ip port
+  read -r ip port < <(timeout 1 ssh -oBatchMode=yes -oControlMaster=no -oControlPath=/ -v $1 |& sed -rn "s/debug1: Connecting to $host \[([^\]*)] port ([0-9]+).*/\1 \2/p")
+  if [[ ! $ip ]]; then
+    echo "khfix: ssh failed"
+    return 1
+  fi
+  if [[ $port != 22 ]]; then
+    ip_entry="[$ip]:$port"
+    host_entry="[$host]:$port"
+  else
+    ip_entry=$ip
+    host_entry=$host
+  fi
+  ssh-keygen -R "$host_entry" -f $(readlink -f ~/.ssh/known_hosts)
+  echo "khfix: removing key for $ip_entry"
+  ssh-keygen -R "$ip_entry" -f $(readlink -f ~/.ssh/known_hosts)
 }
 khfix() { # known hosts fix
-    _khfix_common "$@" || return 1
-    ssh $1 :
+  _khfix_common "$@" || return 1
+  ssh $1 :
 }
 khcopy() {
-    _khfix_common "$@"
-    ssh-copy-id $1
+  _khfix_common "$@"
+  ssh-copy-id $1
 }
 
 a() {
-    beet "${@}"
+  local x
+  x=$(readlink -nf "${1:-$PWD}")
+  # yes, its kinda dumb that xclip/xsel cant do this in one invocation
+  echo -n "$x" | xclip -selection clipboard
+  echo -n "$x" | xclip
 }
 
 ack() { ack-grep "$@"; }
 
-astudio() {
-    # googling android emulator libGL error: failed to load driver: r600
-    # lead to http://stackoverflow.com/a/36625175/14456
-    export ANDROID_EMULATOR_USE_SYSTEM_LIBS=1
-    /a/opt/android-studio/bin/studio.sh "$@" &r;
-}
-
 b() {
-    # backwards
-    c -
-}
-
-bkrun() {
-    # use -p from interactive shell
-    btrbk-run -p "$@"
-}
-
-bfg() { java -jar /a/opt/bfg-1.12.14.jar "$@"; }
-
-btc() {
-    local f=/etc/bitcoin/bitcoin.conf
-    # importprivkey will timeout if using the default of 15 mins.
-    # upped it to 1 hour.
-    bitcoin-cli -rpcclienttimeout=60000 -$(s grep rpcuser= $f) -$(s grep rpcpassword= $f) "$@"
-}
-
-btcusd() {
-    local price
-    price="$(curl -s https://api.coinbase.com/v2/prices/BTC-USD/spot | jq -r .data.amount)"
-    printf "$%s\n" "$price"
-    if [[ $1 ]]; then
-        printf "$%.2f\n" "$(echo "scale=4; $price * $1"| bc -l)"
-    fi
-}
-usdbtc() {
-    local price
-    price="$(curl -s https://api.coinbase.com/v2/prices/BTC-USD/spot | jq -r .data.amount)"
-    printf "$%s\n" "$price"
-    if [[ $1 ]]; then
-        # 100 mil satoshi / btc. 8 digits after the 1.
-        printf "%.8f btc\n" "$(echo "scale=10; $1 / $price "| bc -l)"
-    fi
-}
-satoshi() {
-    local price
-    price="$(curl -s https://api.coinbase.com/v2/prices/BTC-USD/spot | jq -r .data.amount)"
-    price=$(echo "scale=10; $price * 0.00000001"| bc -l)
-    printf "$%f\n" "$price"
-    if [[ $1 ]]; then
-        printf "$%.2f\n" "$(echo "scale=10; $price * $1"| bc -l)"
-    fi
+  # backwards
+  c -
 }
 
 
 # c. better cd
-if [[ $RLC_INSIDE_EMACS ]]; then
+if type -p wcd &>/dev/null; then
+  if [[ $RLC_INSIDE_EMACS ]]; then
     c() { wcd -c -z 50 -o "$@"; }
-else
+  else
     # lets see what the fancy terminal does from time to time
     c() { wcd -c -z 50 "$@"; }
+  fi
+else
+  c() { cd "$@"; }
 fi
 
+c4() { c /var/log/exim4; }
+
 caa() { git commit --amend --no-edit -a; }
 
 caf() {
-    find -L $1 -type f -not \( -name .svn -prune -o -name .git -prune \
-         -o -name .hg -prune -o -name .editor-backups -prune \
-         -o -name .undo-tree-history -prune \) \
-         -exec bash -lc 'hr; echo "$1"; hr; cat "$1"' _ {} \; 2>/dev/null
+  # shellcheck disable=SC2033
+  find -L $1 -type f -not \( -name .svn -prune -o -name .git -prune \
+       -o -name .hg -prune -o -name .editor-backups -prune \
+       -o -name .undo-tree-history -prune \) \
+       -exec bash -lc 'hr; echo "$1"; hr; cat "$1"' _ {} \; 2>/dev/null
 
 }
 
 calc() { echo "scale=3; $*" | bc -l; }
 # no having to type quotes, but also no command history:
 clc() {
-    local x
-    read -r x
-    echo "scale=3; $x" | bc -l
+  local x
+  read -r x
+  echo "scale=3; $x" | bc -l
 }
 
 cam() {
-    git commit -am "$*"
+  git commit -am "$*"
 }
 
+
 ccat () { # config cat. see a config without extra lines.
-    grep '^\s*[^[:space:]#]' "$@"
+  grep '^\s*[^;[:space:]#]' "$@"
 }
 
-cdiff() {
-    # diff config files,
-    # setup for format of postfix, eg:
-    # option = stuff[,]
-    #    [more stuff]
-    local pastline
-    local unified="$(mktemp)"
-    local f1="$(mktemp)"
-    local f2="$(mktemp)"
-    _cdiff-prep "$1" "$f1"
-    _cdiff-prep "$2" "$f2"
-    cat "$f1" "$f2" |  grep -Po '^[^=]+=' | sort | uniq > "$unified"
-    while IFS= read -r line; do
-        # the default bright red / blue doesn't work in emacs shell
-        dwdiff -cblue,red -A best -d "         ," <(grep "^$line" "$f1" || echo ) <(grep "^$line" "$f2" || echo ) | colordiff
-    done < "$unified"
-}
-
-cgpl()
-{
-    if (($#)); then
-        cp /a/bin/data/COPYING "$@"
-    else
-        cp /a/bin/data/COPYING .
+
+_cdiff-prep() {
+  # join options which are continued to multiples lines onto one line
+  local first=true
+  while IFS= read -r line; do
+    # remove leading spaces/tabs. assumes extglob
+    if [[ $line == "[  ]*" ]]; then
+      line="${line##+( )}"
     fi
-}
-capache()
-{
-    if (($#)); then
-        cp /a/bin/data/LICENSE "$@"
+    if $first; then
+      pastline="$line"
+      first=false
+    elif [[ $line == *=* ]]; then
+      echo "$pastline" >> "$2"
+      pastline="$line"
     else
-        cp /a/bin/data/LICENSE .
+      pastline="$pastline $line"
     fi
+  done < <(grep -vE '^([ \t]*#|^[ \t]*$)' "$1")
+  echo "$pastline" >> "$2"
 }
+
+cdiff() {
+  # diff config files,
+  # setup for format of postfix, eg:
+  # option = stuff[,]
+  #    [more stuff]
+  local pastline unified f1 f2
+  unified="$(mktemp)"
+  f1="$(mktemp)"
+  f2="$(mktemp)"
+  _cdiff-prep "$1" "$f1"
+  _cdiff-prep "$2" "$f2"
+  cat "$f1" "$f2" |  grep -Po '^[^=]+=' | sort | uniq > "$unified"
+  while IFS= read -r line; do
+    # the default bright red / blue doesnt work in emacs shell
+    dwdiff -cblue,red -A best -d "     ," <(grep "^$line" "$f1" || echo ) <(grep "^$line" "$f2" || echo ) | colordiff
+  done < "$unified"
+}
+
+
+cat-new-files() {
+  local start=$SECONDS
+  local dir="$1"
+  inotifywait -m "$dir" -e create -e moved_to |
+    # shellcheck disable=SC2030
+    while read -r filedir _ file; do
+      cat "$filedir$file"
+      hr
+      calc $((SECONDS - start)) / 60
+      sleep 5
+    done
+
+}
+
+# shellcheck disable=SC2032
 chown() {
-    # makes it so chown -R symlink affects the symlink and its target.
-    if [[ $1 == -R ]]; then
-        shift
-        command chown -h "$@"
-        command chown -R "$@"
-    else
-        command chown "$@"
-    fi
+  # makes it so chown -R symlink affects the symlink and its target.
+  if [[ $1 == -R ]]; then
+    shift
+    command chown -h "$@"
+    command chown -R "$@"
+  else
+    command chown "$@"
+  fi
 }
 
 cim() {
-    git commit -m "$*"
+  git commit -m "$*"
 }
 
 cl() {
-    # choose recent directory. cl = cd list
-    c =
-}
-
-chrome() {
-    CHROMIUM_FLAGS='--enable-remote-extensions' chromium &r
+  # choose recent directory. cl = cd list
+  c =
 }
 
 d() { builtin bg; }
 complete -A stopped -P '"%' -S '"' d
 
-dat() { # do all tee, for more complex scripts
-    tee >(ssh frodo bash -l) >(bash -l) >(ssh x2 bash -l) >(ssh tp bash -l)
-}
-da() { # do all
-    local host
-    "$@"
-    for host in x2 tp treetowl; do
-        ssh $host "$@"
-    done
-}
 
 dc() {
-    diff --strip-trailing-cr -w "$@"   # diff content
-}
-
-debian_pick_mirror () {
-    # netselect-apt finds a fast mirror.
-    # but we need to replace the mirrors ourselves,
-    # because it doesn't do that. best it can do is
-    # output a basic sources file
-    # here we get the server it found, get the main server we use
-    # then substitute all instances of one for the other in the sources file
-    # and backup original to /etc/apt/sources.list-original.
-    # this is idempotent. the only way to identify debian sources is to
-    # note the original server, so we put it in a comment so we can
-    # identify it later.
-    local file=$(mktemp -d)/f # safe way to get file name without creating one
-    sudo netselect-apt -o "$file" || return 1
-    url=$(grep ^\\w $file | head -n1 | awk '{print $2}')
-    sudo cp -f /etc/apt/sources.list /etc/apt/sources.list-original
-    sudo sed -ri "/http.us.debian.org/ s@( *[^ #]+ +)[^ ]+([^#]+).*@\1$url\2# http.us.debian.org@" /etc/apt/sources.list
-    sudo apt-get update
+  diff --strip-trailing-cr -w "$@"   # diff content
 }
 
 despace() {
-    local x y
-    for x in "$@"; do
-        y="${x// /_}"
-        safe_rename "$x" "$y"
-    done
+  local x y
+  for x in "$@"; do
+    y="${x// /_}"
+    safe_rename "$x" "$y"
+  done
+}
+
+dig() {
+  command dig +nostats +nocmd "$@"
+}
+# Output with sections sorted, and removal of query id, so 2 dig outputs can be diffed.
+digsort() {
+  local sec
+  sec=
+  dig +nordflag "$@" | sed -r 's/^(;; ->>HEADER<<-.*), id: .*/\1/' | while read -r l; do
+    if [[ $l == [^\;]* ]]; then
+      sec+="$l"$'\n'
+    else
+      if [[ $sec ]]; then
+        printf "%s" "$sec" | sort
+        sec=
+      fi
+      printf "%s\n" "$l"
+    fi
+  done
+}
+# compare digs to the 2 servers
+# usage: digdiff @server1 @server2 DIG_ARGS
+# note: only the soa master nameserver will respond with
+# ra "recursive answer" flag. That difference is meaningless afaik.
+digdiff() {
+  local s1 s2
+  s1=$1
+  shift
+  s2=$1
+  shift
+  digsort $s1 "$@" | tee /tmp/digdiff
+  diff -u /tmp/digdiff <(digsort $s2 "$@")
 }
 
 dt() {
-    date "+%A, %B %d, %r" "$@"
+  date "+%A, %B %d, %r" "$@"
 }
 
-dus() {
-    du -sh ${@:-*} | sort -h
+dus() { # du, sorted, default arg of
+  du -sh ${@:-*} | sort -h
 }
 
 
 
 e() { echo "$@"; }
 
-
-ediff() {
-    [[ ${#@} == 2 ]] || { echo "error: ediff requires 2 arguments"; return 1; }
-    emacs --eval "(ediff-files \"$1\" \"$2\")"
+# echo args
+ea() {
+  if (( ! $# )); then
+    echo no args
+  fi
+  for arg; do
+    printf "%qEOL\n" "${arg}"
+    printf "%s" "${arg}" |& hexdump -C
+  done
+}
+# echo vars. print var including escapes, etc
+ev() {
+  if (( ! $# )); then
+    echo no args
+  fi
+  for arg; do
+    printf "%qEOL\n" "${!arg}"
+    printf "%s" "${!arg}" |& hexdump -C
+  done
 }
 
 
-envload() { # load environment from a previous: export > file
-    local file=${1:-$HOME/.${USER}_env}
-    eval "$(export | sed 's/^declare -x/export -n/')"
-    while IFS= read -r line; do
-        # declare -x makes variables local to a function
-        eval ${line/#declare -x/export}
-    done < "$file"
+ediff() {
+  [[ ${#@} == 2 ]] || { echo "error: ediff requires 2 arguments"; return 1; }
+  emacs --eval "(ediff-files \"$1\" \"$2\")"
 }
 
-f() {
-    # cd forward
-    c +
+# mail related
+etail() {
+  tail -F /var/log/exim4/mainlog -n 200
 }
-
-fa() {
-    # find array. make an array of file names found by find into $x
-    # argument: find arguments
-    # return: find results in an array $x
-    while read -rd ''; do
-        x+=("$REPLY");
-    done < <(find "$@" -print0);
-}
-
-faf() { # find all files
-    find -L $1 -type f -not \( -name .svn -prune -o -name .git -prune \
-         -o -name .hg -prune -o -name .editor-backups -prune \
-         -o -name .undo-tree-history -prune \) 2>/dev/null
-}
-
-fastboot() { /a/opt/androidsdk/platform-tools/fastboot "$@"; }
-
-
-# List of apps to install/update
-# Create from existing manually installed apps by doing
-# fdroidcl search -i, then manually removing
-# automatically installed/preinstalled apps
-fdroid_pkgs=(
-    at.bitfire.davdroid
-    com.fsck.k9
-    com.ichi2.anki
-    com.notecryptpro
-    com.nutomic.syncthingandroid
-    com.termux
-    de.danoeh.antennapod
-    de.marmaro.krt.ffupdater
-    # riot
-    im.vector.alpha
-    me.ccrama.redditslide
-    net.gaast.giggity
-    net.osmand.plus
-    # caldav tasks thing
-    org.dmfs.tasks
-    org.fdroid.fdroid
-    org.quantumbadger.redreader
-    org.secuso.privacyfriendlyweather
-    org.smssecure.smssecure
-    org.fedorahosted.freeotp
-    com.ghostsq.commander
-)
-fdup() {
-    local -A installed updated
-    local p
-    fdroidcl update
-    for p in $(fdroidcl search -i| grep -o "^\S\+"); do
-        installed[$p]=true
-    done
-    for p in $(fdroidcl search -u| grep -o "^\S\+"); do
-        updated[$p]=false
-    done
-    for p in ${fdroid_pkgs[@]}; do
-        ${installed[$p]:-false} || fdroidcl install $p
-    done
-    for p in ${!installed[@]}; do
-        ${updated[$p]:-true} || fdroidcl upgrade $p
-    done
+eless() {
+  less /var/log/exim4/mainlog
 }
-
-ff() {
-    if type -P firefox &>/dev/null; then
-        firefox "$@"
-    else
-        iceweasel "$@"
-    fi
+eqcat() {
+  exiqgrep -i | while read i; do
+    exim -Mvh $i; hr; exim -Mvb $i; hr;
+    exigrep $i /var/log/exim4/mainlog; hr
+  done
 }
 
 
-
-fn() {
-    firefox -P alt "$@" >/dev/null 2>&1
+# shellcheck disable=SC2032
+f() {
+  # cd forward
+  c +
 }
 
-
-fsdiff () {
-    local missing=false
-    local dname="${PWD##*/}"
-    local m="/a/tmp/$dname-missing"
-    local d="/a/tmp/$dname-diff"
-    [[ -e $d ]] && rm "$d"
-    [[ -e $m ]] && rm "$m"
-    local msize=0
-    local fsfile
-    while read -r line; do
-        fsfile="$1${line#.}"
-        if [[ -e "$fsfile" ]]; then
-            md5diff "$line" "$fsfile" && tee -a "/a/tmp/$dname-diff" <<< "$fsfile $line"
-        else
-            missing=true
-            echo "$line" >> "$m"
-            msize=$((msize + 1))
-        fi
-    done < <(find -type f )
-    if $missing; then
-        echo "$m"
-        (( msize <= 100 )) && cat $m
-    fi
+fa() {
+  # find array. make an array of file names found by find into $x
+  # argument: find arguments
+  # return: find results in an array $x
+  while read -rd ''; do
+    x+=("$REPLY");
+  done < <(find "$@" -print0);
 }
-fsdiff-test() {
-    # expected output, with different tmp dirs
-    # /tmp/tmp.HDPbwMqdC9/c/d ./c/d
-    # /a/tmp/tmp.qLDkYxBYPM-missing
-    # ./b
-    cd $(mktemp -d)
-    echo ok > a
-    echo nok > b
-    mkdir c
-    echo ok > c/d
-    local x=$(mktemp -d)
-    mkdir $x/c
-    echo different > $x/c/d
-    echo ok > $x/a
-    fsdiff $x
-}
-rename-test() {
-    # test whether missing files were renamed, generally for use with fsdiff
-    # $1 = fsdiff output file, $2 = directory to compare to. pwd = fsdiff dir
-    # echos non-renamed files
-    local x y found
-    unset sums
-    for x in "$2"/*; do
-        { sums+=( "$(md5sum < "$x")" ) ; } 2>/dev/null
-    done
-    while read -r line; do
-        { missing_sum=$(md5sum < "$line") ; } 2>/dev/null
-        renamed=false
-        for x in "${sums[@]}"; do
-            if [[ $missing_sum == "$x" ]]; then
-                renamed=true
-                break
-            fi
-        done
-        $renamed || echo "$line"
-    done < "$1"
-    return 0
+
+faf() { # find all files. use -L to follow symlinks
+  find $@ -not \( -name .svn -prune -o -name .git -prune \
+       -o -name .hg -prune -o -name .editor-backups -prune \
+       -o -name .undo-tree-history -prune \) -type f 2>/dev/null
 }
 
-feh() {
-    # F = fullscren, z = random, Z = auto zoom
-    command feh -FzZ "$@"
+# mail related
+frozen() {
+  rm -rf /tmp/frozen
+  s mailq |gr frozen|awk '{print $3}' | while read -r id; do
+    s exim -Mvl $id
+    echo
+    s exim -Mvh $id
+    echo
+    s exim -Mvb $id
+    echo -e '\n\n##############################\n'
+  done | tee -a /tmp/frozen
+}
+frozenrm() {
+  local ids=()
+  while read -r line; do
+    printf '%s\n' "$line"
+    ids+=($(printf '%s\n' "$line" |gr frozen|awk '{print $3}'))
+  done < <(s mailq)
+  echo "sleeping for 2 in case you change your mind"
+  sleep 2
+  s exim -Mrm "${ids[@]}"
 }
 
 funce() {
-    # like -e for functions. returns on error.
-    # at the end of the function, disable with:
-    # trap ERR
-    trap 'echo "${BASH_COMMAND:+BASH_COMMAND=\"$BASH_COMMAND\" }
+  # like -e for functions. returns on error.
+  # at the end of the function, disable with:
+  # trap ERR
+  trap 'echo "${BASH_COMMAND:+BASH_COMMAND=\"$BASH_COMMAND\" }
 ${FUNCNAME:+FUNCNAME=\"$FUNCNAME\" }${LINENO:+LINENO=\"$LINENO\"  }\$?=$?"
 trap ERR
 return' ERR
 }
 
-
-fw() {
-    firefox -P default "$@" >/dev/null 2>&1
-}
-
 getdir () {
-    local help="Usage: getdir [--help] PATH
+  local help="Usage: getdir [--help] PATH
 Output the directory of PATH, or just PATH if it is a directory."
-    if [[ $1 == --help ]]; then
-        echo "$help"
-        return 0
-    fi
-    if [[ $# -ne 1 ]]; then
-        echo "getdir error: expected 1 argument, got $#"
-        return 1
-    fi
-    if [[ -d $1 ]]; then
-        echo "$1"
+  if [[ $1 == --help ]]; then
+    echo "$help"
+    return 0
+  fi
+  if [[ $# -ne 1 ]]; then
+    echo "getdir error: expected 1 argument, got $#"
+    return 1
+  fi
+  if [[ -d $1 ]]; then
+    echo "$1"
+  else
+    local dir
+    dir="$(dirname "$1")"
+    if [[ -d $dir ]]; then
+      echo "$dir"
     else
-        local dir="$(dirname "$1")"
-        if [[ -d $dir ]]; then
-            echo "$dir"
-        else
-            echo "getdir error: directory does not exist"
-            return 1
-        fi
+      echo "getdir error: directory does not exist"
+      return 1
     fi
+  fi
 }
 
 git_empty_branch() { # start an empty git branch. carefull, it deletes untracked files.
-    [[ $# == 1 ]] || { echo 'need a branch name!'; return 1;}
-    local gitroot
-    gitroot || return 1 # function to set gitroot
-    builtin cd "$gitroot"
-    git symbolic-ref HEAD refs/heads/$1
-    rm .git/index
-    git clean -fdx
+  [[ $# == 1 ]] || { echo 'need a branch name!'; return 1;}
+  local root
+  root=$(gitroot) || return 1 # function to set gitroot
+  builtin cd "$root"
+  git symbolic-ref HEAD refs/heads/$1
+  rm .git/index
+  git clean -fdx
 }
 
+# shellcheck disable=SC2120
 gitroot() {
-    local help="Usage: gitroot [--help]
+  local help="Usage: gitroot [--help]
 Print the full path to the root of the current git repo
 
 Handles being within a .git directory, unlike git rev-parse --show-toplevel,
 and works in older versions of git which did not have that."
-    if [[ $1 == --help ]]; then
-        echo "$help"
-        return
-    fi
-    local p=$(git rev-parse --git-dir) || { echo "error: not in a git repo" ; return 1; }
-    [[ $p != /* ]] && p=$PWD
-    echo "${p%%/.git}"
+  if [[ $1 == --help ]]; then
+    echo "$help"
+    return
+  fi
+  local p
+  p=$(git rev-parse --git-dir) || { echo "error: not in a git repo" ; return 1; }
+  [[ $p != /* ]] && p=$PWD
+  echo "${p%%/.git}"
 }
 
-gmacs() {
-    # quit will prompt if the program crashes.
-    gdb -ex=r -ex=quit --args emacs "$@"; r;
+gh() {
+  # i got an error, gh not found when doing a pull request, it seems like it wants itself in it\'s path.
+  local _oldpath="$PATH"
+  PATH="$PATH:$HOME/node_modules/.bin"
+  command gh "$@"
+  PATH="$_oldpath"
 }
 
-gdkill() {
-    # kill the emacs daemon
-    pk1 emacs --daemon
+gmacs() {
+  # quit will prompt if the program crashes.
+  gdb -ex=r -ex=quit --args emacs "$@"; r;
 }
 
-gse() {
-    git send-email --notes '--envelope-sender=<ian@iankelling.org>' \
-        --suppress-cc=self "$@"
+gdkill() {
+  # kill the emacs daemon
+  pk1 emacs --daemon
 }
 
 gr() {
-    grep -iIP --color=auto "$@"
+  grep -iIP --color=auto "$@"
 }
 
-grr() {
-    if [[ ${#@} == 1 ]]; then
-        grep -riIP --color=auto "$@" .
-    else
-        grep -riIP --color=auto "$@"
-    fi
-}
-
-hstatus() {
-    # do git status on published repos
-    cd /a/bin/githtml
-    for x in !(forks) forks/* ian-specific/*; do
-        cd `readlink -f $x`/..
-        hr
-        echo $x
-        i status
-        cd /a/bin/githtml
-    done
+grr() { # grep recursive
+  if [[ ${#@} == 1 ]]; then
+    grep --exclude-dir='*.emacs.d' --exclude-dir='*.git' -RiIP --color=auto "$@" .
+  else
+    grep --exclude-dir='*.emacs.d' --exclude-dir='*.git' -RiIP --color=auto "$@"
+  fi
 }
-
-hl() { # history limit. Write extra history to archive file.
-    # todo: this is not working or not used currently
-    local max_lines linecount tempfile prune_lines x
-    local harchive="${HISTFILE}_archive"
-    for x in "$HISTFILE" "$harchive"; do
-        [[ -e $x ]] || { touch "$x" && echo "notice from hl(): creating $x"; }
-        if  [[ ! $x || ! -e $x || ! -w $x || $(stat -c "%u" "$x") != $EUID  ]];  then
-            echo "error in hl: history file \$x:$x no good"
-            return 1
-        fi
-    done
-    history -a # save history
-    max_lines=$HISTFILELINES
-    [[ $max_lines =~ ^[0-9]+$ ]] || { echo "error in hl: failed to get max line count"; return 1; }
-    linecount=$(wc -l < $HISTFILE) # pipe so it doesn't output a filename
-    [[ $linecount =~ ^[0-9]+$ ]] || { echo "error in hl: wc failed"; return 1; }
-    if (($linecount > $max_lines)); then
-        prune_lines=$(($linecount - $max_lines))
-        head -n $prune_lines "$HISTFILE" >> "$harchive" \
-            && sed --follow-symlinks -ie "1,${prune_lines}d"  $HISTFILE
-    fi
+rg() {
+  command rg -i -M 200 "$@"
 }
 
 hr() { # horizontal row. used to break up output
-    printf "$(tput setaf 5)â–ˆ$(tput sgr0)%.0s" $(seq ${COLUMNS:-60})
-    echo
+  printf "$(tput setaf 5)â–ˆ$(tput sgr0)%.0s" $(seq ${COLUMNS:-60})
+  echo
 }
 
 hrcat() { local f; for f; do [[ -f $f ]] || continue; hr; echo "$f"; cat "$f"; done }
 
+# get latest hub and run it
+# main command to use:
+# hub pull-request --no-edit
+# --no-edit means to use the first commit\'s message as the pull request message.
+# Also, you need to use a feature branch, not master in your fork.
+# On first use, you input username/pass and it gets an oath token so you dont have to repeat
+# it\'s at ~/.config/hub
+hub() {
+  local up uptar updir p
+  p=/github/hub/releases/
+  up=https://github.com/$(curl -s https://github.com$p| grep -o $p'download/[^/]*/hub-linux-amd64[^"]*' | head -n1)
+  uptar=${up##*/}
+  updir=${uptar%.tgz}
+  if [[ ! -e /a/opt/$updir ]]; then
+    rm -rf /a/opt/hub-linux-amd64*
+    wget -P /a/opt $up
+    tar -C /a/opt -zxf /a/opt/$uptar
+    rm -f /a/opt/$uptar
+    s /a/opt/$updir/install
+  fi
+
+  # save token across computers
+  if [[ ! -L ~/.config/hub ]]; then
+    if [[ -e ~/.config/hub  ]]; then
+      mv ~/.config/hub /p/c/subdir_files/.config/
+    fi
+    if [[ -e /p/c/subdir_files/.config/hub ]]; then
+      conflink
+    fi
+  fi
+  command hub "$@"
+}
 
 i() { git "$@"; }
 # modified from ~/local/bin/git-completion.bash
 # other completion commands are mostly taken from bash_completion package
 complete -o bashdefault -o default -o nospace -F _git i 2>/dev/null \
-    || complete -o default -o nospace -F _git i
+  || complete -o default -o nospace -F _git i
 
 if ! type service &>/dev/null; then
-    service() {
-        echo actually running: systemctl $2 $1
-        systemctl $2 $1
-    }
+  service() {
+    echo actually running: systemctl $2 $1
+    systemctl $2 $1
+  }
 fi
 
+
+
 ic() {
-    # fast commit all
-    git commit -am "$*"
+  # fast commit all
+  git commit -am "$*"
 }
 
-idea() {
-    /a/opt/idea-IC-163.7743.44/bin/idea.sh "$@" &r
-}
+
 
 ifn() {
-    # insensitive find
-    find -L . -not \( -name .svn -prune -o -name .git -prune \
-         -o -name .hg -prune -o -name .editor-backups -prune \
-         -o -name .undo-tree-history -prune \) -iname "*$**" 2>/dev/null
-}
-
-
-if [[ $OS == Windows_NT ]]; then
-    # cygstart wrapper
-    cs() {
-        cygstart "$@" &
-    }
-    xp() {
-        explorer.exe .
-    }
-    # launch
-    o() {
-        local x=(*$1*)
-        (( ${#x[#]} > 1 )) && { echo "warning ${#x[#]} matches found"; sleep 1; }
-        cygstart *$1* &
-    }
-else
-    o() {
-        if type gvfs-open &> /dev/null ; then
-            gvfs-open "$@"
-        else
-            xdg-open "$@"
-        fi
-        # another alternative is run-mailcap
-    }
-fi
+  # insensitive find
+  find -L . -not \( -name .svn -prune -o -name .git -prune \
+       -o -name .hg -prune -o -name .editor-backups -prune \
+       -o -name .undo-tree-history -prune \) -iname "*$**" 2>/dev/null
+}
 
+ipdrop() {
+  s iptables -A INPUT -s $1 -j DROP
+}
 
 
 istext() {
-    grep -Il "" "$@" &>/dev/null
+  grep -Il "" "$@" &>/dev/null
 }
 
 jtail() {
-    journalctl -n 10000 -f "$@" | grep -Evi "^(\S+\s+){4}(sudo|sshd|cron)"
+  journalctl -n 10000 -f "$@"
 }
-
+jr() { journalctl "$@" ; }
+jrf() { journalctl -f "$@" ; }
 
 l() {
-    if [[ $PWD == /[iap] ]]; then
-        command ls -A --color=auto -I lost+found "$@"
-    else
-        command ls -A --color=auto "$@"
-    fi
+  if [[ $PWD == /[iap] ]]; then
+    command ls -A --color=auto -I lost+found "$@"
+  else
+    command ls -A --color=auto "$@"
+  fi
 }
 
 
 lcn() { locate -i "*$**"; }
 
+lg() { LC_COLLATE=C.UTF-8 ll --group-directories-first; }
+
+lt() { ll -tr "$@"; }
+
 lld() { ll -d "$@"; }
 
 low() {  # make filenames lowercase, remove bad chars
-    local f new
-    for f in "$@"; do
-        new="${f,,}" # downcase
-        new="${new//[^[:alnum:]._-]/_}" # sub bad chars
-        new="${new#"${new%%[[:alnum:]]*}"}" # remove leading/trailing non-alnum
-        new="${new%"${new##*[[:alnum:]]}"}"
-        # remove bad underscores, like __ and _._
-        new=$(echo $new | sed -r 's/__+/_/g;s/_+([.-])|([.-])_+/\1/g')
-        safe_rename "$f" "$new" || return 1
-    done
-    return 0
+  local f new
+  for f in "$@"; do
+    new="${f,,}" # downcase
+    new="${new//[^[:alnum:]._-]/_}" # sub bad chars
+    new="${new#"${new%%[[:alnum:]]*}"}" # remove leading/trailing non-alnum
+    new="${new%"${new##*[[:alnum:]]}"}"
+    # remove bad underscores, like __ and _._
+    new=$(echo $new | sed -r 's/__+/_/g;s/_+([.-])|([.-])_+/\1/g')
+    safe_rename "$f" "$new" || return 1
+  done
+  return 0
 }
 
 lower() { # make first letter of filenames lowercase.
-    local x
-    for x in "$@"; do
-        if [[ ${x::1} == [A-Z] ]]; then
-            y=$(tr "[A-Z]" "[a-z]" <<<"${x::1}")"${x:1}"
-            safe_rename "$x" "$y" || return 1
-        fi
-    done
+  local x
+  for x in "$@"; do
+    if [[ ${x::1} == [A-Z] ]]; then
+      y=$(tr '[:upper:]' '[:lower:]' <<<"${x::1}")"${x:1}"
+      safe_rename "$x" "$y" || return 1
+    fi
+  done
 }
 
 
 k() { # history search
-    grep -P --binary-files=text "$@" ${HISTFILE:-~/.bash_history}  | tail -n 80;
+  grep -P --binary-files=text "$@" ${HISTFILE:-~/.bash_history}  | tail -n 80;
 }
 
-
-make-targets() {
-    # show make targets, via http://stackoverflow.com/questions/3063507/list-goals-targets-in-gnu-make
-    make -qp | awk -F':' '/^[a-zA-Z0-9][^$#\/\t=]*:([^=]|$)/ {split($1,A,/ /);for(i in A)print A[i]}'
+ks() { # history search
+  grep -P --binary-files=text "$@" ${HISTFILE:-~/.bash_history}  | uniq;
 }
 
-mbenable() {
-    mb=$1
-    dst=/m/4e/$1
-    src=/m/md/$1
-    set -x
-    mv -T $src $dst || { set +x; return 1; }
-    ln -s -T $dst $src
-    set +x
-}
-mbdisable() {
-    mb=$1
-    dst=/m/md/$1
-    src=/m/4e/$1
-    set -x
-    if [[ -L $dst ]]; then rm $dst; fi
-    mv -T $src $dst
-    set +x
-}
 
+make-targets() {
+  # show make targets, via http://stackoverflow.com/questions/3063507/list-goals-targets-in-gnu-make
+  make -qp | awk -F':' '/^[a-zA-Z0-9][^$#\/\t=]*:([^=]|$)/ {split($1,A,/ /);for(i in A)print A[i]}'
+}
 
 mkc() {
-    mkdir "$1"
-    c "$1"
+  mkdir "$1"
+  c "$1"
 }
 
-mkdir() { command mkdir -p "$@"; }
-
-pithos() {
-    cd /
-    export PYTHONPATH=/a/opt/Pithosfly
-    python3 -m pithos&r
+mkct() {
+  mkc $(mktemp -d)
 }
 
-pakaraoke() {
-    # from http://askubuntu.com/questions/456021/remove-vocals-from-mp3-and-get-only-instrumentals
-    pactl load-module module-ladspa-sink sink_name=Karaoke master=alsa_output.usb-Audioengine_Audioengine_D1-00.analog-stereo plugin=karaoke_1409 label=karaoke control=-30
+mkt() { # mkdir and touch file
+  local path="$1"
+  mkdir -p "$(dirname "$path")"
+  touch "$path"
 }
 
+# shellcheck disable=SC2032
+mkdir() { command mkdir -p "$@"; }
 
-pfind() { #find *$1* in $PATH
-    [[ $# != 1 ]] && { echo requires 1 argument; return 1; }
-    local pathArray
-    IFS=: pathArray=($PATH); unset IFS
-    find "${pathArray[@]}" -iname "*$1*"
+nopanic() {
+  # shellcheck disable=SC2024
+  sudo tee -a /var/log/exim4/paniclog-archive </var/log/exim4/paniclog; sudo truncate -s0 /var/log/exim4/paniclog
 }
 
-pk1() {
-    local pid
-    pid=($(pgrep -f "$*"))
-    case ${#pid[@]} in
-        1)
-            ps -F $pid
-            m kill $pid
-            ;;
-        0) echo "no pid found" ;;
-        *)
-            ps -F ${pid[@]}
-            ;;
-    esac
-}
+p8() { ping 8.8.8.8; }
+p6() { ping6 2001:4860:4860::8888; }
 
-pick-trash() {
-    # trash-restore lists everything that has been trashed at or below CWD
-    # This picks out files just in CWD, not subdirectories,
-    # which also match grep $1, usually use $1 for a time string
-    # which you get from running restore-trash once first
-    local name x ask
-    local nth=1
-    # last condition is to not ask again for ones we skipped
-    while name="$( echo | restore-trash | gr "$PWD/[^/]\+$" | gr "$1" )" \
-            && [[ $name ]] && (( $(wc -l <<<"$name") >= nth )); do
-        name="$(echo "$name" | head -n $nth | tail -n 1 )"
-        read -p "$name [Y/n] " ask
-        if [[ ! $ask || $ask == [Yy] ]]; then
-            x=$( echo "$name"  | gr -o "^\s*[0-9]*" )
-            echo $x | restore-trash > /dev/null
-        elif [[ $ask == [Nn] ]]; then
-            nth=$((nth+1))
-        else
-            return
-        fi
-    done
+pkx() { # package extract
+  local pkg cached tmp f
+  c $(mktemp -d)
+  pkg=$1
+  # shellcheck disable=SC2012
+  cached=$(ls -t /var/cache/apt/archives/$pkg* | tail -n1 2>/dev/null)
+  if [[ $cached ]]; then
+    cp $cached .
+  else
+    aptitude download $pkg || return 1
+  fi
+  tmp=(*); f=${tmp[0]} # only 1 expected
+  ex $f
+  rm -f $f
 }
 
-postconfin() {
-    local MAPFILE
-    mapfile -t
-    local s
-    [[ $EUID == 0 ]] || s=s
-    $s postconf -ev "${MAPFILE[@]}"
-}
-
-pub() {
-    rld /a/h/_site/ li:/var/www/iankelling.org/html
+# pgrep and kill
+pk1() {
+  local pid
+  pid=($(pgrep -f "$*"))
+  case ${#pid[@]} in
+    1)
+      # shellcheck disable=SC2128
+      {
+        ps -F $pid
+        m kill $pid
+      }
+      ;;
+    0) echo "no pid found" ;;
+    *)
+      ps -F ${pid[@]}
+      ;;
+  esac
 }
 
 pubip() { curl -4s https://icanhazip.com; }
+pubip6() { curl -6s https://icanhazip.com; }
 whatismyip() { pubip; }
 
-pumpa() {
-    # fixes the menu bar in xmonad. this won\'t be needed when xmonad
-    # packages catches up on some changes in future (this is written in
-    # 4/2017)
-    #
-    # geekosaur: so you'll want to upgrade to xmonad 0.13 or else use a
-    # locally modified XMonad.Hooks.ManageDocks that doesn't set the
-    # work area; turns out it's impossible to set correctly if you are
-    # not a fully EWMH compliant desktop environment
-    #
-    # geekosaur: chrome shows one failure mode, qt/kde another, other
-    # gtk apps a third, ... I came up with a setting that works for me
-    # locally but apparently doesn't work for others, so we joined the
-    # other tiling window managers in giving up on setting it at all
-    #
-    xprop -root -remove _NET_WORKAREA
-    command pumpa &r
-}
-
-
 pwgen() {
-    # -m = min length
-    # -x = max length
-    # -t = print pronunciation
-    apg -m 12 -x 16 -t
+  # -m = min length
+  # -x = max length
+  # -t = print pronunciation
+  apg -m 14 -x 17 -t
+  for (( i=0; i<10; i++ )); do
+    shuf -n3 /usr/share/hunspell/en_US.dic | sed 's,/.*,,' | paste -sd . -
+
+  done
 }
 
 pwlong() {
-    # -M CLN = use Caps, Lowercase, Numbers
-    # -n 1 = 1 password
-    # -a 1 = use random instead of pronounceable algorithm
-    apg -m 50 -x 70 -n 1 -a 1 -M CLN
+  # -M CLN = use Caps, Lowercase, Numbers
+  # -n 1 = 1 password
+  # -a 1 = use random instead of pronounceable algorithm
+  apg -m 50 -x 70 -n 1 -a 1 -M CLN
 }
 
 
 q() { # start / launch a program in the backround and redir output to null
-    "$@" &> /dev/null &
+  "$@" &> /dev/null &
 }
 
+# shellcheck disable=SC2120
 r() {
-    exit "$@" 2>/dev/null
+  history -a # save history
+  exit ${1:0}
+  # i had this redir, not sure why
+  #  exit "$@" 2>/dev/null
 }
 
-rbpipe() { rbt post -o --diff-filename=- "$@"; }
-rbp() { rbt post -o "$@"; }
-
 rl() {
-    # rsync, root is required to keep permissions right.
-    # rsync  --archive --human-readable --verbose --itemize-changes --checksum \(-ahvic\) \
-        #                                      --no-times --delete
-    # basically, make an exact copy, use checksums instead of file times to be more accurate
-    rsync -ahvic --delete "$@"
+  # rsync, root is required to keep permissions right.
+  # rsync  --archive --human-readable --verbose --itemize-changes --checksum \(-ahvic\) \
+    #                                  --no-times --delete
+  # basically, make an exact copy, use checksums instead of file times to be more accurate
+  rsync -ahvic --delete "$@"
 }
 rld() {
-    # like rlu, but don't delete files on the target end which
-    # do not exist on the original end.
-    rsync -ahvic "$@"
+  # like rlu, but dont delete files on the target end which
+  # do not exist on the original end.
+  rsync -ahvic "$@"
 }
 complete -F _rsync -o nospace rld rl rlt
 
 rlt() {
-    # rl without preserving modification time.
-    rsync -ahvic --delete --no-t "$@"
+  # rl without preserving modification time.
+  rsync -ahvic --delete --no-t "$@"
 }
 
 rlu() { # [OPTS] HOST PATH
-    # eg. rlu -opts frodo /testpath
-    # relative paths will expanded with readlink -f.
-    # useful for selectively sending dirs which have been synced with unison,
-    # where the path is the same on both hosts.
-    opts=("${@:1:$#-2}") #  1 to last -2
-    path="${@:$#}" # last
-    host="${@:$#-1:1}" # last -1
-    if [[ $path == .* ]]; then
-        path=$(readlink -f $path)
-    fi
-    # rync here uses checksum instead of time so we don't mess with
-    # unison relying on time as much. g is for group, same reason
-    # to keep up with unison.
-    s rsync -rlpchviog --relative "${opts[@]}" "$path" "root@$host:/";
+  # eg. rlu -opts frodo /testpath
+  # relative paths will expanded with readlink -f.
+  opts=("${@:1:$#-2}") #  1 to last -2
+  path="${*:$#}" # last
+  host="${*:$#-1:1}" # last -1
+  if [[ $path == .* ]]; then
+    path=$(readlink -f $path)
+  fi
+  # rync here uses checksum instead of time so we dont mess with
+  # unison relying on time as much. g is for group, same reason
+  # to keep up with unison.
+  s rsync -rlpchviog --relative "${opts[@]}" "$path" "root@$host:/";
 }
 
-
-rspicy() { # usage: HOST DOMAIN
-    # connect to spice vm remote host. use vspicy for local host
-    local port=$(ssh $1<<EOF
-sudo virsh dumpxml $2|grep "<graphics.*type='spice'" | \
-       sed -rn "s/.*port='([0-9]+).*/\1/p"
-EOF
-          )
-    if [[ $port ]]; then
-        spicy -h $1 -p $port
-    else
-        echo "error: no port found. check that the domain is running."
-    fi
+rmstrips() {
+  ssh fencepost head -n 300 /gd/gnuorg/EventAndTravelInfo/rms-current-trips.txt | less
 }
 
 s() {
-    # background
-    # I use a function because otherwise we can't use in a script,
-    # can't assign to variable.
-    #
-    # note: gksudo is recommended for X apps because it does not set the
-    # home directory to the same, and thus apps writing to ~ fuck things up
-    # with root owned files.
-    #
-    if [[ $EUID != 0 || $1 == -* ]]; then
-        SUDOD="$PWD" sudo -i "$@"
+  # background
+  # I use a function because otherwise we cant use in a script,
+  # cant assign to variable.
+  #
+  # note: gksudo is recommended for X apps because it does not set the
+  # home directory to the same, and thus apps writing to ~ fuck things up
+  # with root owned files.
+  #
+  if [[ $EUID != 0 || $1 == -* ]]; then
+    SUDOD="$PWD" sudo -i "$@"
+  else
+    "$@"
+  fi
+}
+
+safe_rename() { # warn and dont rename if file exists.
+  # mv -n exists, but it\'s silent
+  if [[ $# != 2 ]]; then
+    echo safe_rename error: $# args, need 2 >2
+    return 1
+  fi
+  if [[ $1 != "$2" ]]; then # yes, we want to silently ignore this
+    if [[ -e $2 || -L $2 ]]; then
+      echo "Cannot rename $1 to $2 as it already exists."
     else
-        "$@"
-    fi
-}
-
-safe_rename() { # warn and don't rename if file exists.
-    # mv -n exists, but it's silent
-    if [[ $# != 2 ]]; then
-        echo safe_rename error: $# args, need 2 >2
-        return 1
-    fi
-    if [[ $1 != $2 ]]; then # yes, we want to silently ignore this
-        if [[ -e $2 || -L $2 ]]; then
-            echo "Cannot rename $1 to $2 as it already exists."
-        else
-            mv -vi "$1" "$2"
-        fi
+      mv -vi "$1" "$2"
     fi
+  fi
 }
 
 
 sb() { # sudo bash -c
-    # use sb instead of s is for sudo redirections,
-    # eg. sb 'echo "ok fine" > /etc/file'
-    local SUDOD="$PWD"
-    sudo -i bash -c "$@"
+  # use sb instead of s is for sudo redirections,
+  # eg. sb 'echo "ok fine" > /etc/file'
+  local SUDOD="$PWD"
+  sudo -i bash -c "$@"
 }
 complete -F _root_command s sb
 
-scssl() {
-    # s gem install scss-lint
-    pushd /a/opt/thoughtbot-guides
-    git pull --stat
-    popd
-    scss-lint -c /a/opt/thoughtbot-guides/style/sass/.scss-lint.yml "$@"
-}
 
 ser() {
-    local s; [[ $EUID != 0 ]] && s=sudo
-    if type -p systemctl &>/dev/null; then
-        $s systemctl $1 $2
-    else
-        $s service $2 $1
-    fi
+  local s; [[ $EUID != 0 ]] && s=s
+  if type -p systemctl &>/dev/null; then
+    $s systemctl $1 $2
+  else
+    $s service $2 $1
+  fi
+}
+# like restart, but do nothing if its not already started
+srestart() {
+  local service=$1
+  if [[ $(s systemctl --no-pager show -p ActiveState $service ) == ActiveState=active ]]; then
+    systemctl restart $service
+  fi
+}
+
+setini() { # set a value in a .ini style file
+  key="$1" value="$2" section="$3" file="$4"
+  if [[ -s $file ]]; then
+    sed -ri -f - "$file" <<EOF
+# remove existing keys
+/ *\[$section\]/,/^ *\[[^]]+\]/{/^\s*$key[[:space:]=]/d}
+# add key
+/^\s*\[$section\]/a $key=$value
+# from section to eof, do nothing
+/^\s*\[$section\]/,\$b
+# on the last line, if we haven't found section yet, add section and key
+\$a [$section]\\
+$key=$value
+EOF
+  else
+    cat >"$file" <<EOF
+[$section]
+$key=$value
+EOF
+  fi
 }
 
 sgo() { # service go
-    service=$1
-    ser restart $service
-    if type -p systemctl &>/dev/null; then
-        ser enable $service
-    fi
+  service=$1
+  ser restart $service || return 1
+  if type -p systemctl &>/dev/null; then
+    ser enable $service
+  fi
+}
+
+sgu() {
+  systemctl list-unit-files | rg "$@"
 }
 
 
-shellck() {
-    # 2086 = unquoted $var
-    # 2046 = unquoted $(cmd)
-    # i had -x as an arg, but debian testing(stretch) doesn't support it
-    shellcheck -e 2086,2046,2068,2006,2119 "$@"
+sk() {
+  # 2086: unquoted $var
+  # 2046: unquoted $(cmd)
+  # 2068: Double quote array expansions to avoid re-splitting elements.
+  # 2119: Functions with optional args get bad warnings when none are passed.
+  # 2033: too many false positives for thing that will never work, passing shell function to find.
+  # i had -x as an arg, but debian testing(stretch) doesn\'t support it
+  shellcheck -x -e 2086,2046,2068,2119,2033 "$@"
+  # had this before. not sure what it is 2119
 }
 
 
 slog() {
-    # log with script. timing is $1.t and script is $1.s
-    # -l to save to ~/typescripts/
-    # -t to add a timestamp to the filenames
-    local logdir do_stamp arg_base
-    (( $# >= 1 )) || { echo "arguments wrong"; return 1; }
-    logdir="/a/dt/"
-    do_stamp=false
-    while getopts "lt" option
-    do
-        case $option in
-            l ) arg_base=$logdir ;;
-            t ) do_stamp=true ;;
-        esac
-    done
-    shift $(($OPTIND - 1))
-    arg_base+=$1
-    [[ -e $logdir ]] || mkdir -p $logdir
-    $do_stamp && arg_base+=$(date +%F.%T%z)
-    script -t $arg_base.s 2> $arg_base.t
+  # log with script. timing is $1.t and script is $1.s
+  # -l to save to ~/typescripts/
+  # -t to add a timestamp to the filenames
+  local logdir do_stamp arg_base
+  (( $# >= 1 )) || { echo "arguments wrong"; return 1; }
+  logdir="/a/dt/"
+  do_stamp=false
+  while getopts "lt" option
+  do
+    case $option in
+      l ) arg_base=$logdir ;;
+      t ) do_stamp=true ;;
+    esac
+  done
+  shift $((OPTIND - 1))
+  arg_base+=$1
+  [[ -e $logdir ]] || mkdir -p $logdir
+  $do_stamp && arg_base+=$(date +%F.%T%z)
+  script -t $arg_base.s 2> $arg_base.t
 }
 splay() { # script replay
-    #logRoot="$HOME/typescripts/"
-    #scriptreplay "$logRoot$1.t" "$logRoot$1.s"
-    scriptreplay "$1.t" "$1.s"
+  #logRoot="$HOME/typescripts/"
+  #scriptreplay "$logRoot$1.t" "$logRoot$1.s"
+  scriptreplay "$1.t" "$1.s"
 }
 
 sr() {
-    # sudo redo. be aware, this command may not work right on strange distros or earlier software
-    if [[ $# == 0 ]]; then
-        sudo -E bash -c -l "$(history -p '!!')"
-    else
-        echo this command redos last history item. no argument is accepted
-    fi
+  # sudo redo. be aware, this command may not work right on strange distros or earlier software
+  if [[ $# == 0 ]]; then
+    sudo -E bash -c -l "$(history -p '!!')"
+  else
+    echo this command redos last history item. no argument is accepted
+  fi
 }
 
 srm () {
-    # with -ll, less secure but faster.
-    command srm -ll "$@"
+  # with -ll, less secure but faster.
+  command srm -ll "$@"
 }
 
 srun() {
-    scp $2 $1:/tmp
-    ssh $1 /tmp/${2##*/} "${@:2}"
+  scp $2 $1:/tmp
+  ssh $1 /tmp/${2##*/} $(printf "%q\n" "${@:2}")
 }
 
+
 swap() {
-    local tmp
-    tmp=$(mktemp)
-    mv $1 $tmp
-    mv $2 $1
-    mv $tmp $2
-}
-
-t() {
-    local x
-    local -a args
-    if type -t trash-put >/dev/null; then
-        # skip args that don't exist, or else trash-put will have an error
-        for x in "$@"; do
-            if [[ -e $x || -L $x ]]; then
-                args+=("$x")
-            fi
-        done
-        [[ ! ${args[@]} ]] || trash-put "${args[@]}"
+  local tmp
+  tmp=$(mktemp)
+  mv $1 $tmp
+  mv $2 $1
+  mv $tmp $2
+}
+
+tclock() { # terminal clock
+  local x
+  clear
+  date +%l:%_M
+  len=60
+  # this goes to full width
+  #len=${1:-$((COLUMNS -7))}
+  x=1
+  while true; do
+    if (( x == len )); then
+      end=true
+      d="$(date +%l:%_M)   "
     else
-        rm -rf "$@"
+      end=false
+      d=$(date +%l:%M:%_S)
     fi
-}
-
-
-tclock() {
-    clear
-    date +%l:%_M
-    len=60
-    # this goes to full width
-    #len=${1:-$((COLUMNS -7))}
-    x=1
-    while true; do
-        if (( x == len )); then
-            end=true
-            d="$(date +%l:%_M)   "
-        else
-            end=false
-            d=$(date +%l:%M:%_S)
-        fi
-        echo -en "\r"
-        echo -n "$d"
-        for ((i=0; i<x; i++)); do
-            if (( i % 6 )); then
-                echo -n _
-            else
-                echo -n .
-            fi
-        done
-        if $end; then
-            echo
-            x=1
-        else
-            x=$((x+1))
-        fi
-        sleep 5
+    echo -en "\r"
+    echo -n "$d"
+    for ((i=0; i<x; i++)); do
+      if (( i % 6 )); then
+        echo -n _
+      else
+        echo -n .
+      fi
     done
+    if $end; then
+      echo
+      x=1
+    else
+      x=$((x+1))
+    fi
+    sleep 5
+  done
 }
 
 
 te() {
-    # test existence / exists
-    local ret=0
-    for x in "$@"; do
-        [[ -e "$x" || -L "$x" ]] || ret=1
-    done
-    return $ret
-}
-
-testmail() {
-    declare -gi _seq; _seq+=1
-    echo "test body" | m mail -s "test mail from $HOSTNAME, $_seq" "${@:-root@localhost}"
-    # for testing to send from an external address, you can do for example
-    # -aFrom:ian@iank.bid web-6fnbs@mail-tester.com
-    # note in exim, you can retry a deferred message
-    # s exim -M MSG_ID
-    # MSG_ID is in /var/log/exim4/mainlog, looks like 1ccdnD-0001nh-EN
-}
-
-# use -eW to actually modify mailbox
-testsievelist() {
-    sieve-filter ~/sieve/main.sieve "$@" >/a/tmp/slog 2> >(tail) && sed -rn '/^Performed actions:/{n;n;p}' /a/tmp/slog | sort -u
-}
-
-
-testsieve() {
-    sieve-filter ~/sieve/main.sieve "$@"
-}
-
-testexim() {
-    # testmail above calls sendmail, which is a link to exim/postfix.
-    # it's docs don't say a way of adding an argument
-    # to sendmail to turn on debug output. We could make a wrapper, but
-    # that is a pain. Exim debug args are documented here:
-    # http://www.exim.org/exim-html-current/doc/html/spec_html/ch-the_exim_command_line.html
-    #
-    # http://www.exim.org/exim-html-current/doc/html/spec_html/ch-building_and_installing_exim.html
-    # note, for exim daemon, you can turn on debug options by
-    # adding -d, etc to COMMONOPTIONS in
-    # /etc/default/exim4
-    # for testing external mail, you need the to address as final cmdline arg
-    exim -d+tls -t <<'EOF'
-From: root@frodo.lan
-To: ian@mail.iankelling.org
-Subject: Testing Exim
-
-This is a test message.
-EOF
+  # test existence / exists
+  local ret=0
+  for x in "$@"; do
+    [[ -e "$x" || -L "$x" ]] || ret=1
+  done
+  return $ret
 }
 
-tm() {
-    # timer in minutes
-    # --no-config
-    (sleep $(calc "$@ * 60") && mpv --no-config --volume 50 /a/bin/data/alarm.mp3) > /dev/null 2>&1 &
-}
 
-
-tu() {
-    local s;
-    local dir="$(dirname "$1")"
-    if [[ -e $1 && ! -w $1 || ! -w $(dirname "$1") ]]; then
-        s=s;
-    fi
-    $s teeu "$@"
-}
-
-tx() { # toggle set -x, and the prompt so it doesn't spam
-    if [[ $- == *x* ]]; then
-        set +x
-        PROMPT_COMMAND=prompt_command
-    else
-        unset PROMPT_COMMAND
-        PS1="\w \$ "
-        set -x
-    fi
+tx() { # toggle set -x, and the prompt so it doesnt spam
+  if [[ $- == *x* ]]; then
+    set +x
+    PROMPT_COMMAND=prompt-command
+    # disabled due to issue on stretch, running ll we get error. something
+    # about the DEBUG trap is broken
+    # if [[ $TERM == *(screen*|xterm*|rxvt*) ]]; then
+    #   trap 'settitle "$BASH_COMMAND"' DEBUG
+    # fi
+  else
+    # normally, i would just execute these commands in the function.
+    # however, DEBUG is not inherited, so we need to run it outside a function.
+    # And we want to run set -x afterwards to avoid spam, so we cram everything
+    # in here, and then it will run after this function is done.
+    #PROMPT_COMMAND='trap DEBUG; unset PROMPT_COMMAND; PS1="\w \$ "; set -x'
+
+    unset PROMPT_COMMAND
+    PS1="\w \$ "
+    set -x
+  fi
 }
 
 psnetns() {
-    # show all processes in the network namespace $1.
-    # blank entries appear to be subprocesses/threads
-    local x netns
-    netns=$1
-    ps -w | head -n 1
-    s find -L /proc/[1-9]*/task/*/ns/net -samefile /run/netns/$netns | cut -d/ -f5 | \
-        while read l; do
-            x=$(ps -w --no-headers -p $l);
-            if [[ $x ]]; then echo "$x"; else echo $l; fi;
-        done
+  # show all processes in the network namespace $1.
+  # blank entries appear to be subprocesses/threads
+  local x netns
+  netns=$1
+  ps -w | head -n 1
+  s find -L /proc/[1-9]*/task/*/ns/net -samefile /run/netns/$netns | cut -d/ -f5 | \
+    while read -r l; do
+      x=$(ps -w --no-headers -p $l);
+      if [[ $x ]]; then echo "$x"; else echo $l; fi;
+    done
 }
 
 m() { printf "%s\n" "$*";  "$@"; }
 
 
-vpncmd() {
-    m s nsenter -t $(pgrep -f "/usr/sbin/openvpn --suppress-timestamps --nobind --config /etc/openvpn/client/client.conf") -n -m "$@"
-}
-vpnf() {
-    vpncmd gksudo -u ian firefox &r
-}
-vpnbash() {
-    vpncmd bash
-}
-
-
-trg() { transmission-remote-gtk&r; }
-
-# transmission() {
-#     local pid=$(cat /var/lib/transmission-daemon/transmission-daemon.pid)
-#     if [[ $pid && -e /proc/$pid ]]; then
-#         echo "noop. already running."
-#         return
-#     fi
-
-#     local NAME=transmission-daemon
-#     local DAEMON=/usr/bin/$NAME
-#     local duser=debian-transmission
-
-#     [ -e /etc/default/$NAME ] && . /etc/default/$NAME
-#     s ip netns exec vpn sudo -u $duser ionice -c 3 nice -n 19 $DAEMON $OPTIONS
-# }
-
 virshrm() {
-    for x in "$@"; do virsh destroy "$x"; virsh undefine "$x"; done
+  for x in "$@"; do virsh destroy "$x"; virsh undefine "$x"; done
 }
 
 vm-set-listen(){
-    local t=$(mktemp)
-    local vm=$1
-    local ip=$2
-    s virsh dumpxml $vm | sed -r "s/(<listen.*address=')([^']+)/\1$ip/" | \
-        sed -r "s/listen='[^']+/listen='$ip/"> $t
-    s virsh undefine $vm
-    s virsh define $t
+  local t
+  t=$(mktemp)
+  local vm=$1
+  local ip=$2
+  s virsh dumpxml $vm | sed -r "s/(<listen.*address=')([^']+)/\1$ip/" | \
+    sed -r "s/listen='[^']+/listen='$ip/"> $t
+  s virsh undefine $vm
+  s virsh define $t
 }
 
 
 vmshare() {
-    vm-set-listen $1 0.0.0.0
+  vm-set-listen $1 0.0.0.0
 }
 
 
 vmunshare() {
-    vm-set-listen $1 127.0.0.1
-}
-
-vpn() {
-    s systemctl start openvpn@client&
-    journalctl --unit=openvpn@client -f -n0
-}
-
-
-vpnoff() {
-    s systemctl stop openvpn@client
+  vm-set-listen $1 127.0.0.1
 }
 
-
-vrm() {
-    virsh destroy $1
-    virsh undefine $1
-}
-
-
-
-vspicy() { # usage: VIRSH_DOMAIN
-    # connect to vms made with virt-install
-    spicy -p $(sudo virsh dumpxml "$1"|grep "<graphics.*type='spice'"|\
-                   sed -r "s/.*port='([0-9]+).*/\1/")
-}
-
-
-whatismyip() { curl ipecho.net/plain ; echo; }
-
-
-#############################
-######### misc stuff ########
-#############################
-
-if [[ $- == *i* ]]; then
-    # commands to run when bash exits normally
-    trap "hl" EXIT
-fi
+# * misc stuff
 
 
 # temporary variables to test colorization
@@ -1483,216 +1194,122 @@ match_lhs=""
 [[ -f ~/.dir_colors   ]] && match_lhs="${match_lhs}$(<~/.dir_colors)"
 [[ -f /etc/DIR_COLORS ]] && match_lhs="${match_lhs}$(</etc/DIR_COLORS)"
 [[ -z ${match_lhs}    ]] \
-    && type -P dircolors >/dev/null \
-    && match_lhs=$(dircolors --print-database)
+  && type -P dircolors >/dev/null \
+  && match_lhs=$(dircolors --print-database)
 # test if our $TERM is in the TERM values in dircolor
 [[ $'\n'${match_lhs} == *$'\n'"TERM "${safe_term}* ]] && use_color=true
 
 
 if ${use_color} && [[ $- == *i* ]]; then
 
-    if [[ $XTERM_VERSION == Cygwin* ]]; then
-        get_term_color() {
-            for x in "$@"; do
-                case $x in
-                   underl) echo -n $'\E[4m' ;;
-                   bold) echo -n $'\E[1m' ;;
-                   red) echo -n $'\E[31m' ;;
-                   green) echo -n $'\E[32m' ;;
-                   blue) echo -n $'\E[34m' ;;
-                   cyan) echo -n $'\E[36m' ;;
-                   yellow) echo -n $'\E[33m' ;;
-                   purple) echo -n $'\E[35m' ;;
-                   nocolor) echo -n $'\E(B\E[m' ;;
-                esac
-            done
-        }
+  term_bold="$(tput bold)"
+  term_red="$(tput setaf 1)"
+  term_green="$(tput setaf 2)"
+  term_yellow="$(tput setaf 3)"
+  term_purple="$(tput setaf 5)"
+  term_nocolor="$(tput sgr0)" # no font attributes
+
+  # unused so far. commented for shellcheck
+  # term_underl="$(tput smul)"
+  # term_blue="$(tput setaf 4)"
+  # term_cyan="$(tput setaf 6)"
 
-    else
-        get_term_color() {
-            for x in "$@"; do
-                case $x in
-                   underl) echo -n $(tput smul) ;;
-                   bold) echo -n $(tput bold) ;;
-                   red) echo -n $(tput setaf 1) ;;
-                   green) echo -n $(tput setaf 2) ;;
-                   blue) echo -n $(tput setaf 4) ;;
-                   cyan) echo -n $(tput setaf 6) ;;
-                   yellow) echo -n $(tput setaf 3) ;;
-                   purple) echo -n $(tput setaf 5) ;;
-                   nocolor) echo -n $(tput sgr0) ;; # no font attributes
-                esac
-            done
-        }
-    fi
-else
-    get_term_color() {
-        :
-    }
 fi
 # Try to keep environment pollution down, EPA loves us.
 unset safe_term match_lhs use_color
 
+# * prompt
 
 
+if [[ $- == *i* ]]; then
 
+  # this needs to come before next ps1 stuff
+  # this stuff needs bash 4, feb 2009,
+  # old enough to no longer condition on $BASH_VERSION anymore
+  shopt -s autocd
+  shopt -s dirspell
+  PS1='\w'
+  if [[ $- == *i* ]]  && [[ ! $RLC_INSIDE_EMACS ]]; then
+    PROMPT_DIRTRIM=2
+    bind -m vi-command B:shell-backward-word
+    bind -m vi-command W:shell-forward-word
+  fi
+
+  if [[ $SSH_CLIENT || $SUDO_USER ]]; then
+    PS1="\h $PS1"
+  fi
+
+  # emacs terminal has problems if this runs slowly,
+  # so I've thrown a bunch of things at the wall to speed it up.
+  prompt-command() {
+    local return=$? # this MUST COME FIRST
+    local ps_char ps_color
+    unset IFS
+    history -a # save history
 
+    case $return in
+      0) ps_color="$term_purple"
+         ps_char='\$'
+         ;;
+      1) ps_color="$term_green"
+         ps_char="$return \\$"
+         ;;
+      *) ps_color="$term_yellow"
+         ps_char="$return \\$"
+         ;;
+    esac
+    if [[ ! -O . ]]; then # not owner
+      if [[ -w . ]]; then # writable
+       ps_color="$term_bold$term_red"
+      else
+       ps_color="$term_bold$term_green"
+      fi
+    fi
 
-###############
-# prompt ######
-###############
-
-
-if [[ $- == *i* ]]; then
-    # git branch/status prompt function
-    if [[ $OS != Windows_NT ]]; then
-        GIT_PS1_SHOWDIRTYSTATE=true
+    # faster than sourceing the file im guessing
+    if [[ -e /dev/shm/iank-status ]]; then
+      eval $(< /dev/shm/iank-status)
     fi
-    # arch source lopip show -fcation
-    [[ -r /usr/share/git/git-prompt.sh ]] && source /usr/share/git/git-prompt.sh
-    # fedora/debian source
-    [[ -r /usr/share/git-core/contrib/completion/git-prompt.sh ]] && source /usr/share/git-core/contrib/completion/git-prompt.sh
-
-    # in case we didn't source git-prompt.sh
-    if ! declare -f __git_ps1 > /dev/null; then
-        __git_ps1() {
-            :
-        }
+    if [[ ! $SSH_CLIENT && $MAIL_HOST != "$HOSTNAME" ]]; then
+      ps_char="@ $ps_char"
     fi
+    PS1="${PS1%"${PS1#*[wW]}"} \[$ps_color\]$ps_char\[$term_nocolor\] "
+  }
+  PROMPT_COMMAND=prompt-command
 
-    # this needs to come before next ps1 stuff
-    # this stuff needs bash 4, feb 2009,
-    # old enough to no longer condition on $BASH_VERSION anymore
-    shopt -s autocd
-    shopt -s dirspell
-    PS1='\w'
-    if [[ $- == *i* ]]  && [[ ! $RLC_INSIDE_EMACS ]]; then
-        PROMPT_DIRTRIM=2
-       bind -m vi-command B:shell-backward-word
-       bind -m vi-command W:shell-forward-word
+  settitle () {
+    if [[ $TERM == screen* ]]; then
+      local title_escape="\033]..2;"
+    else
+      local title_escape="\033]0;"
     fi
-
-    if [[ $SSH_CLIENT ]]; then
-        PS1="\h $PS1"
+    if [[ $0 != prompt-command ]]; then
+      echo -ne "$title_escape$USER@$HOSTNAME ${PWD/#$HOME/~} "
+      printf "%s" "$*"
+      echo -ne "\007"
     fi
+  }
+
+  # for titlebar.
+  # condition from the screen man page i think.
+  # note: duplicated in tx()
+  # disabled. see note in tx
+  # if [[ $TERM == *(screen*|xterm*|rxvt*) ]]; then
+  #   trap 'settitle "$BASH_COMMAND"' DEBUG
+  # else
+  #   trap DEBUG
+  # fi
 
-    prompt_command() {
-        local return=$? # this MUST COME FIRST
-        local psc pst ps_char ps_color stale_subvol
-        unset IFS
-        history -a # save history
-
-        # for titlebar
-        if [[ ! $DESKTOP_SESSION == xmonad && $TERM == *(screen*|xterm*|rxvt*) ]]; then
-            # from the screen man page
-            if [[ $TERM == screen* ]]; then
-                local title_escape="\033]..2;"
-            else
-                local title_escape="\033]0;"
-            fi
-           echo -ne "$title_escape${PWD/#$HOME/~}  $USER@$HOSTNAME\007"
-       fi
-
-
-        case $return in
-           0) ps_color="$(get_term_color blue)"
-               ps_char='\$'
-               ;;
-           1) ps_color="$(get_term_color green)"
-               ps_char="$return \\$"
-               ;;
-           *) ps_color="$(get_term_color yellow)"
-               ps_char="$return \\$"
-               ;;
-        esac
-        if [[ ! -O . ]]; then # not owner
-            if [[ -w . ]]; then # writable
-               ps_color="$(get_term_color bold red)"
-            else
-               ps_color="$(get_term_color bold green)"
-            fi
-        fi
-        # I would set nullglob, but bash has had bugs where that
-        # doesn't work if not in top level.
-        if [[ -e /nocow/btrfs-stale ]] && ((`ls -AUq /nocow/btrfs-stale|wc -l`)); then
-            ps_char="! $ps_char"
-        fi
-        PS1="${PS1%"${PS1#*[wW]}"} \[$ps_color\]$ps_char\[$(get_term_color nocolor)\] "
-        # emacs completion doesn't like the git prompt atm, so disabling it.
-        #PS1="${PS1%"${PS1#*[wW]}"}$(__git_ps1 ' (%s)') \[$ps_color\]$ps_char\[$(get_term_color nocolor)\] "
-    }
-    PROMPT_COMMAND=prompt_command
 fi
 
-
-
-###########################################
-# stuff that makes sense to be at the end #
-###########################################
-if [[ "$SUDOD" ]]; then
-    cd "$SUDOD"
-    unset SUDOD
-elif [[ -d /a ]] && [[ $PWD == $HOME ]] && [[ $- == *i* ]]; then
-    cd /a
-fi
+# * stuff that makes sense to be at the end
 
 
 # best practice
 unset IFS
 
-
-# if someone exported $SOE, catch errors
-if [[ $SOE ]]; then
-    errcatch
-fi
-
-# I'd prefer to have system-wide, plus user ruby, due to bug in it
-# https://github.com/rubygems/rubygems/pull/1002
-# further problems: installing multi-user ruby and user ruby,
-# you don't get multi-user ruby when you sudo to root, unless its sudo -i.
-# There a third hybrid form, which passenger error suggested I use,
-# but it didn't actually work.
-
-# in cased I never need this
-# rvm for non-interactive shell: modified from https://rvm.io/rvm/basics
-#if [[ $(type -t rvm) == file && ! $(type -t ruby) ]]; then
-#    source $(rvm 1.9.3 do rvm env --path)
-#fi
-
-# based on warning from rvmsudo
-export rvmsudo_secure_path=1
-
-# for other script I wrote
-#export ACME_TINY_PATH=/a/opt/acme-tiny
-export ACME_TINY_WRAPPER_CERT_DIR=/p/c/machine_specific/$HOSTNAME/webservercerts
-
-if [[ -s "/usr/local/rvm/scripts/rvm" ]]; then
-    source "/usr/local/rvm/scripts/rvm"
-elif [[ -s $HOME/.rvm/scripts/rvm ]]; then
-    source $HOME/.rvm/scripts/rvm
-fi
-
-export GOPATH=$HOME/go
-path_add $GOPATH/bin
-
-
-path_add --end ~/.npm-global
-
-
-# didn't get drush working, if I did, this seems like the
-# only good thing to include for it.
-# Include Drush completion.
-# if [ -f "/home/ian/.drush/drush.complete.sh" ] ; then
-#     source /home/ian/.drush/drush.complete.sh
-# fi
-
-
-# https://wiki.archlinux.org/index.php/Xinitrc#Autostart_X_at_login
-# i added an extra condition as gentoo xorg guide says depending on
-# $DISPLAY is fragile.
-if [[ ! $DISPLAY && $XDG_VTNR == 1 ]] && shopt -q login_shell && isarch; then
-    exec startx
-fi
+# shellcheck disable=SC1090
+[[ -s "$HOME/.rvm/scripts/rvm" ]] && source "$HOME/.rvm/scripts/rvm" # Load RVM into a shell session *as a function*
 
 
 # ensure no bad programs appending to this file will have an affect